package com.fc2.blog68.symfoware.serve;

import java.io.FileInputStream;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Properties;

import org.apache.thrift.TException;
import org.apache.thrift.server.TServer;
import org.apache.thrift.server.TSimpleServer;
import org.apache.thrift.transport.TServerSocket;
import org.apache.thrift.transport.TServerTransport;

import com.fc2.blog68.symfoware.thrift.*;

public class ServerCore implements SymThriftServer.Iface {

	private static Properties prop;

	@Override
	public boolean execute(String query) throws TException {
		boolean result = false;

		Connection con = null;
		Statement stmt = null;
		try {
			con = getConnection();
			stmt = con.createStatement();

			result = stmt.execute(query);

			con.commit();

			stmt.close();
			con.close();
		} catch (Exception e) {
			try {
				con.rollback();
			} catch (Exception ex) {
				ex.printStackTrace();
			}
			e.printStackTrace();
		}

		return result;
	}

	@Override
	public SymResultSet executeQuery(String query) throws TException {
		SymResultSet result = new SymResultSet();

		Connection con = null;
		Statement stmt = null;
		try {
			con = getConnection();
			stmt = con.createStatement();

			// NGs
			ResultSet rs = stmt.executeQuery(query);
			result.SymRows = new ArrayList<SymRow>();

			// ^f[^擾
			ResultSetMetaData rsmt = rs.getMetaData();
			result.ColumnNames = new ArrayList<String>();

			int columnCount = rsmt.getColumnCount();

			// ݒ
			for (int i = 1; i <= columnCount; i++) {
				// System.out.println(rsmt.getColumnName(i));
				result.ColumnNames.add(rsmt.getColumnName(i));
			}

			while (rs.next()) {
				SymRow row = new SymRow();
				row.SymRowData = new ArrayList<String>();

				for (int i = 1; i <= columnCount; i++) {
					// System.out.println(i);
					row.SymRowData.add(rs.getString(i));
				}
				result.SymRows.add(row);
			}

			rs.close();
			stmt.close();
			con.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return result;
	}

	private Connection getConnection() {

		Connection con = null;

		try {
			// RlNV쐬
			con = DriverManager.getConnection(prop.getProperty("url"));
			con.setAutoCommit(false);

		} catch (Exception e) {
			e.printStackTrace();
		}

		return con;
	}

	public static void main(String[] args) {
		try {
			
			prop = new Properties();
			prop.load(new FileInputStream("jdbcthrift.properties"));
			
			int port = Integer.parseInt(prop.getProperty("port"));
			
			Class.forName(prop.getProperty("driver"));

			ServerCore handler = new ServerCore();
			SymThriftServer.Processor processor = new SymThriftServer.Processor(
					handler);
			TServerTransport serverTransport = new TServerSocket(port);
			TServer server = new TSimpleServer(processor, serverTransport);

			System.out.println("Starting the server...");
			server.serve();

		} catch (Exception x) {
			x.printStackTrace();
		}
		System.out.println("done.");
	}
}
